<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加账号',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加IoT平台' : '编辑'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  kdKey: [{ required: true, message: "请输入快递100 key", trigger: "blur" }],
  kdCustomer: [
    { required: true, message: "请输入快递100 customer", trigger: "blur" },
  ],
  kdSecret: [
    { required: true, message: "请输入快递100 secret", trigger: "blur" },
  ],
  kdUserId: [
    { required: true, message: "请输入快递100 userId", trigger: "blur" },
  ],
  tenantId: [{ required: true, message: "请选择租户", trigger: "change" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = [];
const config = computed(() => {
  return [
    {
      attrs: {
        label: "租户名称",
        prop: "type",
      },
      render(type) {
        return "华为";
      },
    },
    {
      attrs: {
        label: "快递100 key",
        prop: "kdKey",
      },
    },
    {
      attrs: {
        label: "快递100 customer",
        prop: "kdCustomer",
      },
    },
    {
      attrs: {
        label: "快递100 secret",
        prop: "kdSecret",
      },
    },
    {
      attrs: {
        label: "快递100 userId",
        prop: "kdUserId",
      },
    },

    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/configInfo/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {
    type: "1",
  },
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = computed(() => {
  return [
    {
      type: "select",
      prop: "tenantId",
      label: "租户",
      disabled: modalType.value === "edit",
      isLoad: {
        url: "/tenantInfo/page",
        req: {
          pageNum: 1,
          pageSize: 9999,
        },
        labelKey: "enterpriseName",
        labelVal: "tenantId",
        method: "post",
        resUrl: "rows",
      },
    },
    {
      type: "input",
      prop: "kdKey",
      label: "快递100 key",
    },
    {
      type: "input",
      prop: "kdCustomer",
      label: "快递100 customer",
    },
    {
      type: "input",
      prop: "kdSecret",
      label: "快递100 secret",
    },
    {
      type: "input",
      prop: "kdUserId",
      label: "快递100 userId",
    },
  ];
});
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/configInfo/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};

const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};
const selection = ref({
  data: [],
});
const select = (_selection, row) => {
  selection.value.data = _selection;
  console.log(_selection.length);
};
const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/configInfo/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/configInfo/detail", { id: row.id }).then((res) => {
    formData.data = res;
    dialogVisible.value = true;
  });
};

getList();
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>